#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <unistd.h>
#include <pci/pci.h>


off_t addr;
size_t size;
off_t fb_addr;
size_t fb_size;

static struct pci_access *pacc;
static struct pci_filter filter;

/*static u16
get_conf_word(u8* config, unsigned int pos) {
	return config[pos] | (config[pos+1] << 8);
}*/

static u32
get_conf_long(u8* config, unsigned int pos) {
	return config[pos] | (config[pos+1] << 8) | (config[pos+2] << 16) | (config[pos+3] << 24);
}

int get_pci() {
	struct pci_dev *p;

	//char classbuf[128], devbuf[128];
	char filter_bus[] = "01:00.0";
	char filter_vendor[] = "1002:";
	int i;
	int cnt = 3;
	unsigned int config_cached = 64;

	pacc = pci_alloc();

	pci_filter_init(pacc, &filter);
	pci_filter_parse_slot( &filter, filter_bus);
	pci_filter_parse_id( &filter, filter_vendor);

	pci_init(pacc);
	pci_scan_bus(pacc);
	for(p=pacc->devices; p; p=p->next) {
		if (pci_filter_match(&filter, p)) {
			//fprintf(stdout, "%d %s, %x %x %s, %d\n", p->device_class, pci_lookup_name(pacc, classbuf, sizeof(classbuf), PCI_LOOKUP_CLASS, p->device_class), p->vendor_id, p->device_id, pci_lookup_name(pacc, devbuf, sizeof(devbuf), PCI_LOOKUP_VENDOR | PCI_LOOKUP_DEVICE, p->vendor_id, p->device_id), p->dev);

			u8* config = malloc(64);
			bzero(config, sizeof(config));
			if (!pci_read_block(p, 0, config, 64)) {
				fprintf(stderr, "Unable to read the standard configuration space header");
				return 1;
			}

			pci_setup_cache(p, config, config_cached);
			pci_fill_info(p, PCI_FILL_IDENT | PCI_FILL_CLASS | PCI_FILL_IRQ | PCI_FILL_BASES | PCI_FILL_ROM_BASE | PCI_FILL_SIZES);
			//u16 cmd = get_conf_word(config, PCI_COMMAND);

			for ( i = 0; i < cnt; i++) {
				u32 flg = get_conf_long(config, PCI_BASE_ADDRESS_0 + 4*i);
				pciaddr_t pos = p->base_addr[i];
				pciaddr_t len = (p->known_fields & PCI_FILL_SIZES) ? p->size[i] : 0;

				if (!(flg & PCI_BASE_ADDRESS_SPACE_IO)) {
					int t = flg & PCI_BASE_ADDRESS_MEM_TYPE_MASK;
					pciaddr_t a = pos & PCI_ADDR_MEM_MASK;
					int done = 0;
					u32 z = 0;

					if (t == PCI_BASE_ADDRESS_MEM_TYPE_64) {
						if (i >= cnt - 1) {
							// <invalid-64bit-slot>
							done = 1;
						} else {
							i++;
							z = get_conf_long(config, PCI_BASE_ADDRESS_0 + 4*i);
						}
					}
					/*if (!done) {
						if (a) {
							printf(PCIADDR_T_FMT, a);
						//} else {
							//printf(((flg & PCI_BASE_ADDRESS_MEM_MASK) || z) ? "<ignored>" : "<unassigned>");
						}
					}*/

					if (!(flg & PCI_BASE_ADDRESS_MEM_PREFETCH) && (len < 1048576)) {
						// This is FB_ADDR and FB_SIZE
						addr = a;
						size = len;
					} else if ((flg & PCI_BASE_ADDRESS_MEM_PREFETCH) && (len > 1048576)) {
						// This is ADDR and SIZE
						fb_addr = a;
						fb_size = len;
					}
				}
			}
		}
	}
	
	pci_cleanup(pacc);

	return 0;
}
